#include "connector_edid_page1.h"
#include "ui_connector_edid_page1.h"
#include <QString>
#include <QMenu>
#include <QMenuBar>
#include <QAction>
#include <QFileDialog>
#include <QDebug>

connector_edid_page1::connector_edid_page1(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::connector_edid_page1)
{
    ui->setupUi(this);
    this->setWindowTitle("loongson-vbios-creator-1.0");
    EDID_INFO = new edid_info();
    File = new QMenu();
    File = menuBar()->addMenu(tr("&File"));
    loadAction = new QAction(tr("load"), this);
    helpAciton = new QAction(tr("clear"), this);

    File->addAction(loadAction);
    File->addAction(helpAciton);

    connect(loadAction, SIGNAL(triggered()), this, SLOT(slot_load()));
    connect(helpAciton, SIGNAL(triggered()), this, SLOT(slot_clear()));
}

connector_edid_page1::~connector_edid_page1()
{
    delete EDID_INFO;
    delete loadAction;
    delete helpAciton;
    delete File;
    delete ui;
}

void connector_edid_page1::cache_edid_data(const QString &filename)
{
    ui->edid_vbios_text->clear();
    QFile edid(filename);
    edid.open(QFile::ReadOnly);
    QByteArray buf = edid.readAll();
    QString dst = QByteArray(buf);
    dst = dst.remove(QRegExp("\\s"));

    QString strDis;
    int sum = 0;
    strDis += "\n";

    if (dst.length() > 512){
       strDis += QString::asprintf("overflow %d ,check input values\n",dst.length());
       goto show_result;
    }

    for(int i = 0, m = 0 ;i<dst.length ();i+=2 ,m++){
       bool ok;
       QString st = dst.mid (i,2);
       EDID_INFO->internal_edid[m] = st.toInt(&ok,16);
       strDis += QString::asprintf(" %#x",EDID_INFO->internal_edid[m]);
       if (  m%15 == 0 && m!=0)
           strDis += "\n";
       sum++;
    }
    this->count = sum;
    EDID_INFO->number = sum;
show_result:
    ui->edid_vbios_text->appendPlainText(strDis);
    edid.close();
    return;
}

void connector_edid_page1::slot_load()
{
    QString fileName = QFileDialog::getOpenFileName(this,
                                                      tr("打开文件！"),
                                                      ".",
                                                      tr("edid配置文件(*txt)"));
    if(fileName.isEmpty())
        return;
    this->cache_edid_data(fileName);
    return;
}

void connector_edid_page1::slot_clear()
{
    ui->edid_vbios_text->clear();
}

void connector_edid_page1::on_add_edid_btn_clicked()
{
    QString str1 = ui->edid_vbios_text->toPlainText();
    str1 = str1.remove(QRegExp("\\s"));
    QString strDis;

    int sum = 0;
    strDis += "\n";
    if (str1.length() > 512){
        strDis += QString::asprintf("overflow %d ,check input values\n",str1.length());
        goto show_result;
    }

    for(int i = 0, m = 0 ;i<str1.length ();i+=2 ,m++){
        bool ok;
        QString st = str1.mid (i,2);
        EDID_INFO->internal_edid[m] = st.toInt(&ok,16);
        strDis += QString::asprintf(" %#x",EDID_INFO->internal_edid[m]);
        if (  m%15 == 0 && m!=0)
            strDis += "\n";
        sum++;
    }

    EDID_INFO->number = sum;
show_result:
    ui->edid_vbios_text->appendPlainText(strDis);
}

void connector_edid_page1::on_clear_edid_btn_clicked()
{
    ui->edid_vbios_text->clear();
}
