#include "encoder_config_page1.h"
#include "ui_encoder_config_page1.h"
#include <QPushButton>
#include <QFile>
#include <QFileDialog>
#include <QDebug>
#include <QLoggingCategory>
#include <QStandardPaths>
#include <QString>
#include <QByteArray>
#include <QProgressBar>
#include <QPalette>
#include <QColor>
#include <QFont>
#include <QPushButton>
#include <QLineEdit>
#include <QJsonParseError>
#include <QJsonDocument>
#include <QJsonArray>
#include <QJsonObject>
#include <QJsonValue>

static int index_row1 = -1;
encoder_config_page1::encoder_config_page1(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::encoder_config_page1)
{
    ui->setupUi(this);
    this->setWindowTitle("loongson-vbios-creator-1.0");
    QPalette palette1;

    for(int i=0;i<10;i++){
          QPushButton *btni = new QPushButton(this);
          btni->setText(tr("Load"));
          Btn1.append(btni);
          ui->tableWidget->setCellWidget(i,4,Btn1[i]);
          connect(Btn1[i],SIGNAL(clicked()),this,SLOT(handle_config_data1()));

          QProgressBar *bari= new QProgressBar(this);
          bari->setRange(0,100);
          bari->setValue(0);
          bari->setAlignment(Qt::AlignHCenter);
          Bar1.append(bari);
          ui->tableWidget->setCellWidget(i,3,Bar1[i]);

          QLineEdit *lineediti = new QLineEdit(this);
          lineediti->setText("NULL");

          palette1.setColor(QPalette::Text,Qt::blue);
          lineediti->setPalette(palette1);
          lineediti->setAlignment(Qt::AlignCenter);
          LineEd1.append(lineediti);
          ui->tableWidget->setCellWidget(i,2,LineEd1[i]);
    }

    all_cfg1 = new config_all[10];
    memset(all_cfg1,0,sizeof(struct config_all));
}

encoder_config_page1::~encoder_config_page1()
{
    delete [] all_cfg1;
    delete ui;
}

int encoder_config_page1::get_cell_row1()
{
    int row = -1;
    QObject *obj = sender();
    QPushButton *bttemp = qobject_cast<QPushButton *>(obj);
    for(int i=0;i<10;i++){
        if(this->Btn1[i] == bttemp)
        {
           index_row1 = i;
           row = index_row1;
           return row;
        }
    }
    return row;
}

int encoder_config_page1::statistics_config_group1()
{
    int number = 0;
    for(int k=0;k<10;k++){
        if(this->Bar1[k]->value() == 100){
            number++;
        }
    }
    return number;
}

int encoder_config_page1::handle_config_data1()
{
   this->handle_json_config1();
   return 0;
}

int encoder_config_page1::handle_json_config1()
{
    bool ok;
    QString str = QFileDialog::getOpenFileName(this,"打开",
                  QStandardPaths::writableLocation(QStandardPaths::DocumentsLocation),"*(*.json)");
    //加一条，若str为空，直接退出
    if(str.isEmpty())
        return 1;
    QFile file(str);
    QFileInfo fileinfo;
    QString filename,name;
    QStringList tmpname;

    fileinfo = QFileInfo(str);
    filename = fileinfo.fileName();
    tmpname = filename.split(".");
    name = tmpname[0];

    QStringList namelist = name.split("_");
    QString hstring = namelist[0];
    QString vstring = namelist[1];

    this->get_cell_row1();

    if(!file.open(QIODevice::ReadOnly)) {
          qDebug() << "File open failed!";
      } else {
          qDebug() <<"File open successfully!";
      }


    QJsonParseError *error=new QJsonParseError;
    QJsonDocument jdc=QJsonDocument::fromJson(file.readAll(),error);
    if(error->error!=QJsonParseError::NoError)
    {
      qDebug()<<"parseJson:"<<error->errorString();
      return 1;
    }

    QJsonArray array = jdc.array();
    for (int i = 0; i < array.count(); i++){
        QJsonValue value = array.at(i);
        if(value.type() == QJsonValue::Object){
           QJsonObject obj = value.toObject();
           QStringList list =  obj.keys();

           foreach (QString key, list) {
               if(key.contains("dev_addr")){
                   if(obj[key].isString()){
                       QString temp = obj[key].toString();
                       int data1 = temp.toInt(&ok,16);
                       all_cfg1[index_row1].config_regs[i].dev_addr = data1;
                   }
               }

               if(key.contains("reg")){
                   if(obj[key].isString()){
                       QString temp2 = obj[key].toString();
                       int data2 = temp2.toInt(&ok,16);
                       all_cfg1[index_row1].config_regs[i].reg = data2;
                   }
               }

               if(key.contains("value")){
                   if(obj[key].isString()){
                       QString temp3 = obj[key].toString();
                       int data3 = temp3.toInt(&ok,16);
                       all_cfg1[index_row1].config_regs[i].value = data3;
                   }
               }
           }
        }
    }

    all_cfg1[index_row1].reg_num = array.count();

    if(config_type1 == 1){
        QTableWidgetItem * itemhtmp = new QTableWidgetItem(hstring);
        QTableWidgetItem * itemvtmp = new QTableWidgetItem(vstring);
        ui->tableWidget->setItem(index_row1,0,itemhtmp);
        ui->tableWidget->setItem(index_row1,1,itemvtmp);

        all_cfg1[index_row1].hdisplay = hstring.toInt(&ok,10);
        all_cfg1[index_row1].vdisplay = vstring.toInt(&ok,10);
    }

    Bar1[index_row1]->setValue(100);
    LineEd1[index_row1]->setText(name);
    return 0;
}

