#include "encoder_config_page2.h"
#include "ui_encoder_config_page2.h"
#include <QPushButton>
#include <QFile>
#include <QFileDialog>
#include <QDebug>
#include <QLoggingCategory>
#include <QStandardPaths>
#include <QString>
#include <QByteArray>
#include <QProgressBar>
#include <QPalette>
#include <QColor>
#include <QFont>
#include <QPushButton>
#include <QLineEdit>
#include <QJsonParseError>
#include <QJsonDocument>
#include <QJsonArray>
#include <QJsonObject>
#include <QJsonValue>


static int index_row = -1;
encoder_config_page2::encoder_config_page2(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::encoder_config_page2)
{
    ui->setupUi(this);
    this->setWindowTitle("loongson-vbios-creator-1.0");
    QPalette palette2;

    for(int i=0;i<10;i++){
          QPushButton *bti = new QPushButton(this);
          Btn2.append(bti);

          Btn2[i]->setText(tr("Load"));
          ui->tableWidget->setCellWidget(i,4,Btn2[i]);
          connect(Btn2[i],SIGNAL(clicked()),this,SLOT(handle_config_data2()));

          QProgressBar *bari = new QProgressBar(this);
          bari->setRange(0,100);
          bari->setValue(0);
          bari->setAlignment(Qt::AlignHCenter);
          Bar2.append(bari);
          ui->tableWidget->setCellWidget(i,3,Bar2[i]);

          QLineEdit *lineediti  = new QLineEdit();
          lineediti->setText("NULL");
          palette2.setColor(QPalette::Text,Qt::blue);
          lineediti->setPalette(palette2);
          lineediti->setAlignment(Qt::AlignCenter);
          LineEd.append(lineediti);
          ui->tableWidget->setCellWidget(i,2,LineEd[i]);
    }


    all_cfg2 = new config_all[10];
    memset(all_cfg2,0,sizeof(struct config_all));
}

encoder_config_page2::~encoder_config_page2()
{
    delete ui;
}

int encoder_config_page2::get_cell_row()
{
    int row = -1;
    QObject *obj = sender();
    QPushButton *bttemp = qobject_cast<QPushButton *>(obj);
    for(int i=0;i<10;i++){
        if(this->Btn2[i] == bttemp)
        {
           index_row = i;
           row = index_row;
           return row;
        }
    }
    return row;
}

int encoder_config_page2::QString2HexInt(QString str)
{
    if(!str.compare("0")){
        return 0;
    }

    int Byte = 0;
    if(str.length() == 1){
        Byte = str.toInt();
        return Byte;
    }
    int numHigh,numLow;
    numHigh = numLow = 0;
    QByteArray PublishPlotocal,tempByteHigh,tempByteLow;
    PublishPlotocal = str.toLatin1();
    tempByteHigh[0] = PublishPlotocal.at(0);
    numHigh = tempByteHigh.toInt(nullptr,16);

    tempByteLow[0] = PublishPlotocal.at(1);
    numLow = tempByteLow.toInt(nullptr,16);
    Byte = numHigh*16 + numLow*1;
    return Byte;
}

int encoder_config_page2::statistics_config_group()
{
    int number = 0;
    for(int k=0;k<10;k++){
        if(this->Bar2[k]->value() == 100){
            number++;
        }
    }
    return number;
}

int encoder_config_page2::handle_config_data2()
{
   this->handle_json_config2();
   return 0;
}

int encoder_config_page2::handle_json_config2()
{
    bool ok;
    QString str = QFileDialog::getOpenFileName(this,"打开",
                  QStandardPaths::writableLocation(QStandardPaths::DocumentsLocation),"*(*.json)");
    if(str.isEmpty())
        return 1;

    QFile file(str);
    QFileInfo fileinfo;
    QString filename,name;
    QStringList tmpname;

    fileinfo = QFileInfo(str);
    filename = fileinfo.fileName();
    tmpname = filename.split(".");
    name = tmpname[0];

    QStringList namelist2 = name.split("_");
    QString hstring2 = namelist2[0];
    QString vstring2 = namelist2[1];

    this->get_cell_row();

    if(!file.open(QIODevice::ReadOnly)) {
          qDebug() << "File open failed!";
      } else {
          qDebug() <<"File open successfully!";
    }


    QJsonParseError *error=new QJsonParseError;
    QJsonDocument jdc=QJsonDocument::fromJson(file.readAll(),error);
    if(error->error!=QJsonParseError::NoError)
    {
      qDebug()<<"parseJson:"<<error->errorString();
      return 1;
    }

    QJsonArray array = jdc.array();
    for (int i = 0; i < array.count(); i++){
        QJsonValue value = array.at(i);
        if(value.type() == QJsonValue::Object){
           QJsonObject obj = value.toObject();
           QStringList list =  obj.keys();

           foreach (QString key, list) {
               if(key.contains("dev_addr")){
                   if(obj[key].isString()){
                       QString temp = obj[key].toString();
                       int data1 = temp.toInt(&ok,16);
                       all_cfg2[index_row].config_regs[i].dev_addr = data1;
                   }
               }

               if(key.contains("reg")){
                   if(obj[key].isString()){
                       QString temp2 = obj[key].toString();
                       int data2 = temp2.toInt(&ok,16);
                       all_cfg2[index_row].config_regs[i].reg = data2;
                   }
               }

               if(key.contains("value")){
                   if(obj[key].isString()){
                       QString temp3 = obj[key].toString();
                       int data3 = temp3.toInt(&ok,16);
                       all_cfg2[index_row].config_regs[i].value = data3;
                   }
               }

           }
        }
    }

    all_cfg2[index_row].reg_num = array.count();
    if(config_type == 1){
        QTableWidgetItem * itemh2tmp = new QTableWidgetItem(hstring2);
        QTableWidgetItem * itemv2tmp = new QTableWidgetItem(vstring2);
        ui->tableWidget->setItem(index_row,0,itemh2tmp);
        ui->tableWidget->setItem(index_row,1,itemv2tmp);

        all_cfg2[index_row].hdisplay = hstring2.toInt(&ok,10);
        all_cfg2[index_row].vdisplay = vstring2.toInt(&ok,10);
    }

    Bar2[index_row]->setValue(100);
    LineEd[index_row]->setText(name);
    return 0;
}

