#include "hexspinbox.h"

HexSpinBox::HexSpinBox(QWidget *parent) : QSpinBox(parent)
{
      setRange(0,0xff);
      validator = new QRegExpValidator(QRegExp("^[A-Za-z0-9]+$"),this);
}


QValidator::State  HexSpinBox::validate(QString &text, int &pos) const
{
    return validator->validate(text,pos);
}


int HexSpinBox::valueFromText(const QString &text) const
{
    bool ok;
    return text.toInt(&ok,16);
}


QString HexSpinBox::textFromValue(int value) const
{
    return QString::number(value,16).toUpper();
}
