#include "list_head.h"
static inline void INIT_LIST_HEAD(struct list_head *list)
{
        list->next = list;
        list->prev = list;
}

static inline void __list_add(struct list_head *pnew, struct list_head *prev,struct list_head *next)
{
        next->prev = pnew;
        pnew->next = next;
        pnew->prev = prev;
        prev->next = pnew;
}

static inline void list_add(struct list_head *pnew, struct list_head *head)
{
        __list_add(pnew, head, head->next);
}

static inline void __list_del(struct list_head * prev, struct list_head * next)
{
        next->prev = prev;
        prev->next = next;
}

static inline void list_del(struct list_head *entry)
{
        __list_del(entry->prev, entry->next);
        entry->next = NULL;
        entry->prev = NULL;
}
