#ifndef LOONGSON_DATA_H
#define LOONGSON_DATA_H

typedef unsigned char u8;
typedef unsigned int u32;
struct vbios_conf_reg{
    u8 dev_addr;
    u8 reg;
    u8 value;
};

struct config_all{
    u8 reg_num;
    u32 hdisplay;
    u32 vdisplay;
    struct vbios_conf_reg config_regs[256];
} __attribute__ ((packed));;

struct edid_info{
    int number;
    u8 internal_edid[256];
};

enum desc_type {
    desc_header = 0,
    desc_crtc,
    desc_encoder,
    desc_connector,
    desc_i2c,
    desc_pwm,
    desc_gpio,
    desc_backlight,
    desc_fan,
    desc_irq_vblank,
    desc_cfg_encoder,
    desc_max = 0xffff
};

enum gpio_placement {
    _3A4000 = 0,
    _7A1000
};

enum encoder_object{
    Unknown = 0x00,
    Internal_Dvo = 0x01,
    Internal_Hdmi = 0x02,
    Vga_Ch7055 = 0x10,
    Vga_Adv7125 = 0x11,
    Dvi_Tfp410 = 0x20,
    Hdmi_It66121 = 0x30,
    Hdmi_Sil9022 = 0x31,
    Hdmi_Lt8618 = 0x32,
    Hdmi_Ms7210 = 0x33,
    Edp_Ncs8805 = 0x40,

};

enum desc_ver {
    ver_v1,
};

enum hotplug {
    disable = 0,
    polling,
    irq,
    hotplug_max = 0xffffffff,
}__attribute__ ((packed));

enum vbios_backlight_type {
    bl_unuse,
    bl_ec,
    bl_pwm
};

enum i2c_type {
       i2c_cpu,
       i2c_gpio,
       i2c_max = -1
};

enum loongson_edid_method {
    via_null = 0,
    via_i2c,
    via_vbios,
    via_encoder,
    via_max = 0xffffffff,
}__attribute__ ((packed));


enum encoder_config{
    encoder_transparent = 0,
    encoder_os_config,
    encoder_bios_config, //bios config encoder
    encoder_timing_filling,
    encoder_kernel_driver,
    encoder_type_max = 0xffffffff,
}__attribute__ ((packed));


enum connector_type {
    connector_unknown,
    connector_vga,
    connector_dvii,
    connector_dvid,
    connector_dvia,
    connector_composite,
    connector_svideo,
    connector_lvds,
    connector_component,
    connector_9pindin,
    connector_displayport,
    connector_hdmia,
    connector_hdmib,
    connector_tv,
    connector_edp,
    connector_virtual,
    connector_dsi,
    connector_dpi
};

enum encoder_type{
    encoder_none,
    encoder_dac,
    encoder_tmds,
    encoder_lvds,
    encoder_tvdac,
    encoder_virtual,
    encoder_dsi,
    encoder_dpmst,
    encoder_dpi
};


#endif // LOONGSON_DATA_H
